<template>
  <div class="menu">
    <img src="../assets/imgs/home_img_logo.png" alt class="logo" />
    <div
      style="float:right;cursor: pointer;position:relative;"
      class="user_hover"
    >
      <span class="user">{{ userInfo.user_name }}</span>
      <img
        class="user_pic"
        :src="
          userInfo.picture_path || require('../assets/imgs/home_ic_user.png')
        "
      />
      <div class="user_menu">
        <div
          v-for="(item, index) in user_arr"
          :key="index + 700"
          @click="gotopage(item.path)"
        >
          {{ item.name }}
        </div>
      </div>
      <div class="sj"></div>
    </div>
    <div
      style="float:right;cursor: pointer;position:relative;"
      class="shop_hover"
    >
      <div class="number">99+</div>
      <img src="../assets/imgs/home_ic_shop.png" alt class="car" />
      <div class="shop_menu">
        <div class="shop_list_title">最近加入的服务：</div>
        <div
          v-for="(item, index) in shopping_list"
          :key="'shopping' + index"
          class="shop_list_cell shop_line"
        >
          <img :src="item.service.cover" class="shop_img" />
          <div class="shop_cell_msgs">
            <p @click="getDetail(item.id)" class="shop_cell_name over_one">
              {{
                item.service_id == 0
                  ? item.application.app_name
                  : item.service.name
              }}
            </p>
            <p class="shop_cell_msg bover_one">
              {{
                item.service_id == 0
                  ? item.application.ywly
                  : item.service.sectors_name
              }}
            </p>
            <p class="shop_cell_msg over_one">
              {{
                item.service_id == 0
                  ? item.application.org
                  : item.service.organization_name
              }}
            </p>
          </div>
          <div>
            <img
              @click.stop="deleteItem(item.id)"
              src="../assets/imgs/ic_delete.png"
              alt
            />
          </div>
        </div>
        <div class="shop_footer">
          <el-button @click="settlement" size="small" class="shop_settlement"
            >去购物车申请结算</el-button
          >
        </div>
      </div>
      <div class="shop_sj"></div>
    </div>

    <div style="float:right">
      <div
        v-for="(item, index) in menu_arr"
        :key="index + 200"
        class="menu_box user_hover"
        @click="navAction(index, item.path)"
        :style="{ color: now_menu == index ? '#fff' : '' }"
      >
        {{ item.name }}
        <div
          class="user_menu"
          v-if="item.children && item.children.length"
          style="left: 30px;"
        >
          <div
            v-for="(v, indexs) in item.children"
            :key="indexs + 700"
            @click.stop="gotoChildPage(v, index)"
          >
            {{ v.name }}
          </div>
        </div>
        <div
          class="sj"
          v-if="item.children && item.children.length"
          style="left: 60px;"
        ></div>
        <div class="bottom_show" v-if="now_menu == index"></div>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  data() {
    return {
      menu_arr: [
        {
          name: "工作台",
          path: "/workplace",
          children: [
            {
              name: "服务注册",
              path: "/fwzc/fwcs",
            },
            {
              name: "服务管理",
              path: "/fwgl/",
            },
            {
              name: "应用管理",
              path: "/yygl/",
            },
          ],
        },
        {
          name: "技术支持",
          path: "/xxx",
        },
        {
          name: "服务超市",
          path: "/services_shop",
          children: [
            {
              name: "数据服务",
              path: "/shop/data_service_list/5",
            },
            {
              name: "时空服务",
              path: "/shop/space_time_service_list/6",
            },
            {
              name: "视频服务",
              path: "/shop/video_service_list/7",
            },
            {
              name: "感知服务",
              path: "/shop/perception_service_list/10",
            },
            {
              name: "综合应用",
              path: "/shop/comprehensive_app_list/11",
            },
            {
              name: "云资源服务",
              path: "/shop/cloud",
            },
            {
              name: "应用商店",
              path: "/shop/app_store_list/12",
            },
          ],
        },
      ],
      now_menu: 2,
      user_arr: [
        { name: "个人档案", path: "/user/user_info" },
        { name: "消息通知", path: "/user/message" },
        { name: "关于BD-aPaaS", path: "/data_analysis" },
        { name: "退出登录", path: "logout" },
      ],
      shopping_list: [],
    };
  },
  mounted() {
    this.$api.user.getNowUser().then(({ data }) => {
      if (data.success == 1) {
        this.$store.commit("userInfofun", data.data);

        const userLevel = this.$store.getters.level;

        if (userLevel === 2) {
          this.user_arr = [
            { name: "个人档案", path: "/user/user_info" },
            { name: "消息通知", path: "/user/message" },
            { name: "收银中心", path: "/authority" },
            { name: "关于BD-aPaaS", path: "/data_analysis" },
            { name: "退出登录", path: "logout" },
          ];
        }
      } else {
        console.log(data.errMsg);
      }
    });

    this.getMenuIndex();
    this.getList();
  },
  computed: {
    getMenuCartState() {
      return this.$store.state.menuCartState;
    },
    userInfo() {
      return this.$store.state.userInfo || {};
    },
  },
  watch: {
    getMenuCartState(newVal) {
      this.getList();
    },
  },
  methods: {
    gotopage(n) {
      if (n == "logout") {
        let path = this.$route.path;
        window.location.href = "/iam/api/logout?ReturnUrl=" + path;
      } else {
        this.$router.push(n);
      }
    },
    settlement() {
      this.$router.push({ name: "shoppingCart" });
    },
    deleteItem(id) {
      let query = [id];
      this.$api.serviceShop.delShoppingCart(query).then((response) => {
        this.getList();
      });
    },
    getDetail() {
      // if you want goto detail page, you should give me the type at first
      // at here, we will goto shopping cart
      this.$router.push({ name: "shoppingCart" });
    },
    navAction(index, path) {
      this.$router.push(path);
      this.now_menu = index;
      window.sessionStorage.setItem("menuIndex", index);
    },
    gotoChildPage(v, parent) {
      if (v.path) {
        if (v.path == "/fwgl/" || v.path == "/yygl/") {
          this.$router.push(v.path + this.$store.getters.level);
        } else if (parent == 2) {
          this.$router.push(v.path);
          this.$store.commit("serviceShopMenuAct", v.path);
        } else {
          this.$router.push(v.path);
        }
        this.now_menu = parent;
        window.sessionStorage.setItem("menuIndex", parent);
      }
    },
    getList() {
      this.$api.serviceShop.getShoppingCart().then((response) => {
        if (response.data.success == "1") {
          console.log(response.data.data);
          this.shopping_list = response.data.data.valid
            ? response.data.data.valid.slice(0, 3)
            : [];
        } else {
          console.log(response.data.message);
        }
      });
    },
    getMenuIndex() {
      let index = window.sessionStorage.getItem("menuIndex");
      console.log(index);
      this.now_menu = index ? index : 2;
    },
  },
};
</script>

<style scoped>
.menu {
  width: 100%;
  height: 84px;
  background-color: #0f2683;
  color: #8390ee;
  line-height: 84px;
}
.logo {
  float: left;
  margin: 30px 0 0 40px;
}
.user {
  float: right;
  margin-right: 113px;
  font-size: 16px;
}
.user_pic {
  float: right;
  margin-right: 15px;
  margin-top: 30px;
}
.number {
  float: right;
  margin-right: 43px;
  margin-top: 30px;
  width: 40px;
  height: 22px;
  background-color: #e56600;
  border-radius: 11px;
  color: #fcefd6;
  line-height: 22px;
  text-align: center;
}
.car {
  float: right;
  margin-right: 15px;
  margin-top: 30px;
}
.menu_box {
  float: right;
  width: 185px;
  text-align: center;
  cursor: pointer;
  position: relative;
}
.menu_box:nth-of-type(1) {
  margin-right: 52px;
}
.bottom_show {
  width: 24px;
  height: 5px;
  background-color: #e56600;
  border-radius: 3px;
  position: absolute;
  bottom: 0px;
  left: calc(50% - 12px);
}
.user_menu {
  width: 135px;
  background-color: #ffffff;
  box-shadow: 0px 3px 6px 0px #f4f7fc;
  border-radius: 8px;
  position: absolute;
  top: 80px;
  left: -20px;
  overflow: hidden;
  display: none;
  z-index: 1;
}
.shop_menu {
  width: 280px;
  background-color: #ffffff;
  box-shadow: 0px 3px 6px 0px #f4f7fc;
  border-radius: 8px;
  position: absolute;
  top: 80px;
  left: -20px;
  overflow: hidden;
  display: none;
  z-index: 1;
  padding: 10px 20px;
}
.user_hover:hover .user_menu {
  display: block;
}
.user_hover:hover .sj {
  display: block;
}
.shop_hover {
  height: 100%;
}
.shop_hover:hover .shop_menu {
  display: block;
}
.shop_hover:hover .shop_sj {
  display: block;
}
.user_menu div {
  width: 135px;
  height: 44px;
  line-height: 44px;
  text-align: center;
  color: #0d1847;
}
.user_menu div:hover {
  background-color: #e56600;
  color: #fff;
}
.sj {
  width: 16px;
  height: 16px;
  background-color: #e56600;
  position: absolute;
  top: 72px;
  transform: rotate(45deg);
  display: none;
}
.shop_sj {
  width: 16px;
  height: 16px;
  background-color: #fff;
  position: absolute;
  top: 72px;
  transform: rotate(45deg);
  display: none;
}
.shop_list_title {
  color: #8890a7;
  font-size: 14px;
  height: 30px;
  line-height: 30px;
}
.shop_list_cell {
  height: 80px;
  padding: 10px 0;
  display: flex;
  line-height: 26px;
}
.shop_line {
  border-bottom: #f4f7fc 2px solid;
}
.shop_line:nth-last-child(2) {
  border-bottom: 0;
}
.shop_img {
  width: 60px;
  height: 60px;
  border-radius: 8px;
}
.shop_footer {
  width: 100%;
  height: 50px;
  text-align: right;
  padding: 15px 0;
  line-height: 30px;
}
.shop_settlement {
  background-color: #e56600;
  color: #fcefd6;
}
.shop_cell_msgs {
  width: calc(100% - 80px);
  margin-left: 10px;
}
.shop_cell_name {
  color: #2d3867;
  font-size: 14px;
  line-height: 24px;
}
.shop_cell_name:hover {
  color: #0d0807;
}
.shop_cell_msg {
  color: #8890a7;
  font-size: 12px;
  line-height: 18px;
}
.over_one {
  overflow: hidden;
  text-overflow: ellipsis;
  white-space: nowrap;
}
</style>
